/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateInstallationPrepareDate type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallationPrepareDate{}

// CxTemplateInstallationPrepareDate struct for CxTemplateInstallationPrepareDate
type CxTemplateInstallationPrepareDate struct {
	Languages []string `json:"languages,omitempty"`
	FallbackLanguage *string `json:"fallback_language,omitempty"`
	Messengers []string `json:"messengers,omitempty"`
}

// NewCxTemplateInstallationPrepareDate instantiates a new CxTemplateInstallationPrepareDate object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallationPrepareDate() *CxTemplateInstallationPrepareDate {
	this := CxTemplateInstallationPrepareDate{}
	return &this
}

// NewCxTemplateInstallationPrepareDateWithDefaults instantiates a new CxTemplateInstallationPrepareDate object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationPrepareDateWithDefaults() *CxTemplateInstallationPrepareDate {
	this := CxTemplateInstallationPrepareDate{}
	return &this
}

// GetLanguages returns the Languages field value if set, zero value otherwise.
func (o *CxTemplateInstallationPrepareDate) GetLanguages() []string {
	if o == nil || IsNil(o.Languages) {
		var ret []string
		return ret
	}
	return o.Languages
}

// GetLanguagesOk returns a tuple with the Languages field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationPrepareDate) GetLanguagesOk() ([]string, bool) {
	if o == nil || IsNil(o.Languages) {
		return nil, false
	}
	return o.Languages, true
}

// HasLanguages returns a boolean if a field has been set.
func (o *CxTemplateInstallationPrepareDate) HasLanguages() bool {
	if o != nil && !IsNil(o.Languages) {
		return true
	}

	return false
}

// SetLanguages gets a reference to the given []string and assigns it to the Languages field.
func (o *CxTemplateInstallationPrepareDate) SetLanguages(v []string) {
	o.Languages = v
}

// GetFallbackLanguage returns the FallbackLanguage field value if set, zero value otherwise.
func (o *CxTemplateInstallationPrepareDate) GetFallbackLanguage() string {
	if o == nil || IsNil(o.FallbackLanguage) {
		var ret string
		return ret
	}
	return *o.FallbackLanguage
}

// GetFallbackLanguageOk returns a tuple with the FallbackLanguage field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationPrepareDate) GetFallbackLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.FallbackLanguage) {
		return nil, false
	}
	return o.FallbackLanguage, true
}

// HasFallbackLanguage returns a boolean if a field has been set.
func (o *CxTemplateInstallationPrepareDate) HasFallbackLanguage() bool {
	if o != nil && !IsNil(o.FallbackLanguage) {
		return true
	}

	return false
}

// SetFallbackLanguage gets a reference to the given string and assigns it to the FallbackLanguage field.
func (o *CxTemplateInstallationPrepareDate) SetFallbackLanguage(v string) {
	o.FallbackLanguage = &v
}

// GetMessengers returns the Messengers field value if set, zero value otherwise.
func (o *CxTemplateInstallationPrepareDate) GetMessengers() []string {
	if o == nil || IsNil(o.Messengers) {
		var ret []string
		return ret
	}
	return o.Messengers
}

// GetMessengersOk returns a tuple with the Messengers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationPrepareDate) GetMessengersOk() ([]string, bool) {
	if o == nil || IsNil(o.Messengers) {
		return nil, false
	}
	return o.Messengers, true
}

// HasMessengers returns a boolean if a field has been set.
func (o *CxTemplateInstallationPrepareDate) HasMessengers() bool {
	if o != nil && !IsNil(o.Messengers) {
		return true
	}

	return false
}

// SetMessengers gets a reference to the given []string and assigns it to the Messengers field.
func (o *CxTemplateInstallationPrepareDate) SetMessengers(v []string) {
	o.Messengers = v
}

func (o CxTemplateInstallationPrepareDate) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallationPrepareDate) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Languages) {
		toSerialize["languages"] = o.Languages
	}
	if !IsNil(o.FallbackLanguage) {
		toSerialize["fallback_language"] = o.FallbackLanguage
	}
	if !IsNil(o.Messengers) {
		toSerialize["messengers"] = o.Messengers
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallationPrepareDate struct {
	value *CxTemplateInstallationPrepareDate
	isSet bool
}

func (v NullableCxTemplateInstallationPrepareDate) Get() *CxTemplateInstallationPrepareDate {
	return v.value
}

func (v *NullableCxTemplateInstallationPrepareDate) Set(val *CxTemplateInstallationPrepareDate) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallationPrepareDate) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallationPrepareDate) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallationPrepareDate(val *CxTemplateInstallationPrepareDate) *NullableCxTemplateInstallationPrepareDate {
	return &NullableCxTemplateInstallationPrepareDate{value: val, isSet: true}
}

func (v NullableCxTemplateInstallationPrepareDate) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallationPrepareDate) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


